SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

ALTER TABLE `SCET`.`Empresas` DROP FOREIGN KEY `fk_Empresas_Ubicaciones` ;

ALTER TABLE `SCET`.`Acciones` DROP FOREIGN KEY `fk_Acciones_Entrada_Equipos10` ;

ALTER TABLE `SCET`.`Clientes` DROP FOREIGN KEY `fk_Clientes_Ubicaciones` ;

ALTER TABLE `SCET`.`Objetos` CHANGE COLUMN `referencia` `referencia` VARCHAR(50) NULL DEFAULT NULL  , CHANGE COLUMN `nombre` `nombre` VARCHAR(100) NULL DEFAULT NULL  ;

ALTER TABLE `SCET`.`Talleres` 
DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idTalleres`) ;

ALTER TABLE `SCET`.`Entidades` CHANGE COLUMN `referencia` `referencia` VARCHAR(50) NULL DEFAULT NULL  , CHANGE COLUMN `nombre` `nombre` VARCHAR(100) NULL DEFAULT NULL  ;

ALTER TABLE `SCET`.`Caracteristicas` DROP COLUMN `actualisacion` , ADD COLUMN `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP  AFTER `valor` , CHANGE COLUMN `valor` `valor` MEDIUMTEXT NULL DEFAULT NULL  ;

ALTER TABLE `SCET`.`Especificaciones` DROP COLUMN `actualisacion` , ADD COLUMN `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP  AFTER `valor` , CHANGE COLUMN `valor` `valor` MEDIUMTEXT NULL DEFAULT NULL  ;

ALTER TABLE `SCET`.`Tecnicos` 
DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idTecnicos`) ;

ALTER TABLE `SCET`.`Ubicaciones` CHANGE COLUMN `referencia` `referencia` VARCHAR(50) NULL DEFAULT NULL  , CHANGE COLUMN `nombre` `nombre` VARCHAR(100) NULL DEFAULT NULL  , CHANGE COLUMN `descripcion` `descripcion` MEDIUMTEXT NULL DEFAULT NULL  ;

ALTER TABLE `SCET`.`Descripciones` DROP COLUMN `actualisacion` , ADD COLUMN `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP  AFTER `valor` ;

ALTER TABLE `SCET`.`Almasenes` 
DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idAlmasenes`) ;

ALTER TABLE `SCET`.`Empresas` DROP COLUMN `idUbicaciones` 
, DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idEmpresas`) 
, DROP INDEX `fk_Empresas_Ubicaciones` ;

ALTER TABLE `SCET`.`Herramientas` 
DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idHerramientas`) ;

ALTER TABLE `SCET`.`Entradas` DROP COLUMN `fecha_salida` , DROP COLUMN `fecha_entrada` , ADD COLUMN `fecha` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP  AFTER `idEmpresas` , ADD COLUMN `descripcion` MEDIUMTEXT NULL DEFAULT NULL  AFTER `fecha` , CHANGE COLUMN `idClientes` `idClientes` INT(10) UNSIGNED NOT NULL  AFTER `refenrencia` , CHANGE COLUMN `refenrencia` `refenrencia` VARCHAR(50) NULL DEFAULT NULL  ;

CREATE  TABLE IF NOT EXISTS `SCET`.`Trabajos` (
  `idTrabajos` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT ,
  `idEquipos` INT(10) UNSIGNED NOT NULL ,
  `idTalleres` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `idAlmasenes` INT(10) UNSIGNED NULL DEFAULT NULL ,
  `idEntradas` INT(10) UNSIGNED NOT NULL ,
  `fecha` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
  `estado` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '0: En proceso\n1: Terminado' ,
  INDEX `fk_Entradas_has_Equipos_Entradas1` (`idEntradas` ASC) ,
  PRIMARY KEY (`idTrabajos`) ,
  INDEX `fk_Entrada_Equipos_Talleres` (`idTalleres` ASC) ,
  INDEX `fk_Entrada_Equipos_Almasenes` (`idAlmasenes` ASC) ,
  INDEX `fk_Entrada_Equipos_Equipos` (`idEquipos` ASC) ,
  CONSTRAINT `fk_Entrada_Equipos_Entradas`
    FOREIGN KEY (`idEntradas` )
    REFERENCES `SCET`.`Entradas` (`idEntradas` )
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Talleres`
    FOREIGN KEY (`idTalleres` )
    REFERENCES `SCET`.`Talleres` (`idTalleres` )
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Almasenes`
    FOREIGN KEY (`idAlmasenes` )
    REFERENCES `SCET`.`Almasenes` (`idAlmasenes` )
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Equipos`
    FOREIGN KEY (`idEquipos` )
    REFERENCES `SCET`.`Equipos` (`idEquipos` )
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

ALTER TABLE `SCET`.`Acciones` DROP COLUMN `idEntrada_Equipos` , ADD COLUMN `idTecnicos` INT(10) UNSIGNED NULL DEFAULT NULL  AFTER `idAcciones` , ADD COLUMN `idHerramientas` INT(10) UNSIGNED NULL DEFAULT NULL  AFTER `idTecnicos` , ADD COLUMN `idTrabajos` INT(10) UNSIGNED NOT NULL  AFTER `idHerramientas` , ADD COLUMN `estado` TINYINT(1) NOT NULL DEFAULT 0  AFTER `descripcion` , 
  ADD CONSTRAINT `fk_Acciones_Trabajos`
  FOREIGN KEY (`idTrabajos` )
  REFERENCES `SCET`.`Trabajos` (`idTrabajos` )
  ON DELETE CASCADE
  ON UPDATE CASCADE, 
  ADD CONSTRAINT `fk_Acciones_Tecnicos`
  FOREIGN KEY (`idTecnicos` )
  REFERENCES `SCET`.`Tecnicos` (`idTecnicos` )
  ON DELETE CASCADE
  ON UPDATE CASCADE, 
  ADD CONSTRAINT `fk_Acciones_Herramientas`
  FOREIGN KEY (`idHerramientas` )
  REFERENCES `SCET`.`Herramientas` (`idHerramientas` )
  ON DELETE CASCADE
  ON UPDATE CASCADE
, DROP INDEX `fk_Acciones_Entrada_Equipos1` 
, ADD INDEX `fk_Acciones_Entrada_Equipos1` (`idTrabajos` ASC) 
, ADD INDEX `fk_Acciones_Tecnicos` (`idTecnicos` ASC) 
, ADD INDEX `fk_Acciones_Herramientas` (`idHerramientas` ASC) ;

ALTER TABLE `SCET`.`Clientes` DROP COLUMN `idUbicaciones` 
, DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idClientes`) 
, DROP INDEX `fk_Clientes_Ubicaciones` ;

ALTER TABLE `SCET`.`Equipos` 
DROP PRIMARY KEY 
, ADD PRIMARY KEY (`idEquipos`) ;

ALTER TABLE `SCET`.`Informacion_Fiscal` CHANGE COLUMN `rif_tipo` `rif_tipo` CHAR(1) NOT NULL  , CHANGE COLUMN `rif_numero` `rif_numero` DECIMAL(8,0) NOT NULL  , CHANGE COLUMN `rif_final` `rif_final` DECIMAL(1,0) NULL DEFAULT NULL  ;

DROP TABLE IF EXISTS `SCET`.`Tecnicos_Entrada_Equipos` ;

DROP TABLE IF EXISTS `SCET`.`Entrada_Equipos` ;


-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Talleres`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Talleres` (`idTalleres` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idUbicaciones` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Tecnicos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Tecnicos` (`idTecnicos` INT, `nombre` INT, `referencia` INT, `idEmpresas` INT, `idEntidades` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Almasenes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Almasenes` (`idAlmasenes` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idUbicaciones` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Herramientas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Herramientas` (`idHerramientas` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idObjetos` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Clientes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Clientes` (`idClientes` INT, `idEntidades` INT, `nombre` INT, `referencia` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Equipos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Equipos` (`idEquipos` INT, `idObjetos` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idClientes` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Empresas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Empresas` (`idEmpresas` INT, `idEntidades` INT, `nombre` INT, `referencia` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Entradas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Entradas` (`idEntradas` INT, `idTrabajos` INT, `idEquipos` INT, `idObjetos` INT, `idClientes` INT, `idEntidades` INT, `cliente` INT, `codigo` INT, `equipo` INT, `serial` INT, `descripcion` INT, `estado` INT);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Talleres`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Talleres`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Talleres` AS
SELECT 
    `a`.`idTalleres`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idUbicaciones`
FROM `Talleres` AS `a` 
LEFT JOIN `Ubicaciones` AS `b` ON (`a`.`idUbicaciones` = `b`.`idUbicaciones`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Tecnicos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Tecnicos`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Tecnicos` AS
SELECT 
    `a`.`idTecnicos`,
    `b`.`nombre`,
    `b`.`referencia`,
    `a`.`idEmpresas`,
    `b`.`idEntidades`
FROM `Tecnicos` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Almasenes`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Almasenes`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Almasenes` AS
SELECT 
    `a`.`idAlmasenes`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idUbicaciones`
FROM `Almasenes` AS `a` 
LEFT JOIN `Ubicaciones` AS `b` ON (`a`.`idUbicaciones` = `b`.`idUbicaciones`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Herramientas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Herramientas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Herramientas` AS
SELECT 
    `a`.`idHerramientas`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idObjetos`
FROM `Herramientas` AS `a` 
LEFT JOIN `Objetos` AS `b` ON (`a`.`idObjetos` = `b`.`idObjetos`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Clientes`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Clientes`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Clientes` AS
SELECT 
    `a`.`idClientes`,
    `b`.`idEntidades`,
    `b`.`nombre`,
    `b`.`referencia`
FROM `Clientes` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Equipos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Equipos`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Equipos` AS
SELECT 
    `a`.`idEquipos`,
    `b`.`idObjetos`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idClientes`
FROM `Equipos` AS `a` 
LEFT JOIN `Objetos` AS `b` ON (`a`.`idObjetos` = `b`.`idObjetos`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Empresas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Empresas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Empresas` AS
SELECT 
    `a`.`idEmpresas`,
    `b`.`idEntidades`,
    `b`.`nombre`,
    `b`.`referencia`
FROM `Empresas` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);


USE `SCET`;

-- -----------------------------------------------------
-- View `SCET`.`_Entradas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`_Entradas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Entradas` AS
SELECT
    `a`.`idEntradas`,
    `b`.`idTrabajos`,
    `c`.`idEquipos`,
    `d`.`idObjetos`,
    `e`.`idClientes`,
    `f`.`idEntidades`,
    `f`.`nombre` AS `cliente`,
    `f`.`referencia` AS `codigo`,
    `d`.`nombre`  AS `equipo`,
    `d`.`referencia`  AS `serial`,    
    `d`.`descripcion`,
    `b`.`estado`
FROM `Entradas` AS `a`
INNER JOIN `Trabajos` AS `b` ON (`a`.`idEntradas` = `b`.`idEntradas`)
INNER JOIN `Equipos` AS `c` ON (`b`.`idEquipos` = `c`.`idEquipos`)
INNER JOIN `Objetos` AS `d` ON (`c`.`idObjetos` = `d`.`idObjetos`)
LEFT JOIN `Clientes` AS `e` ON (`a`.`idClientes` = `e`.`idClientes`)
LEFT JOIN `Entidades` AS `f` ON (`e`.`idEntidades` = `f`.`idEntidades`);

DELIMITER $$
USE `SCET`$$
CREATE FUNCTION CAPITALISAR (input VARCHAR(255))

RETURNS VARCHAR(255)

DETERMINISTIC

BEGIN
	DECLARE len INT;
	DECLARE i INT;

	SET len   = CHAR_LENGTH(input);
	SET input = LOWER(input);
	SET i = 0;

	WHILE (i < len) DO
		IF (MID(input,i,1) = ' ' OR i = 0) THEN
			IF (i < len) THEN
				SET input = CONCAT(
					LEFT(input,i),
					UPPER(MID(input,i + 1,1)),
					RIGHT(input,len - i - 1)
				);
			END IF;
		END IF;
		SET i = i + 1;
	END WHILE;

	RETURN input;
END;$$

DELIMITER ;

DELIMITER $$
USE `SCET`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `CHQ_EXISTENCIA`(IN TABLA VARCHAR(100), IN COL VARCHAR(100), IN ID INT, INOUT R TINYINT(1))
BEGIN

SET @C = 1;

SET @cmd = CONCAT('SELECT count(*) INTO @C FROM ', TABLA, ' WHERE ', COL, ' = ', ID, ';');
PREPARE proc FROM @cmd;
EXECUTE proc;

IF @C > 0 THEN
    SET R = TRUE;
ELSE
    SET R = FALSE;
END IF;

DEALLOCATE PREPARE proc;

END$$

DELIMITER ;

DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Objetos_BINS` BEFORE INSERT ON `Objetos` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Entidades_BINS` BEFORE INSERT ON `Entidades` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Caracteristicas_BINS` BEFORE INSERT ON `Caracteristicas` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Especificaciones_BINS` BEFORE INSERT ON `Especificaciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Ubicaciones_BINS` BEFORE INSERT ON `Ubicaciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Descripciones_BINS` BEFORE INSERT ON `Descripciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Entradas_BINS` BEFORE INSERT ON `Entradas` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Trabajos_BINS` BEFORE INSERT ON `Trabajos` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Acciones_BINS` BEFORE INSERT ON `Acciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Contacto_BINS` BEFORE INSERT ON `Contacto` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
END;$$


DELIMITER ;


DELIMITER $$

USE `SCET`$$


CREATE TRIGGER `Informacion_Fiscal_BINS` BEFORE INSERT ON `Informacion_Fiscal` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.razon_social = CAPITALISAR(NEW.razon_social);
SET NEW.estado = CAPITALISAR(NEW.estado);
SET NEW.ciudad = CAPITALISAR(NEW.ciudad);
SET NEW.direccion = CAPITALISAR(NEW.direccion);
SET NEW.rif_tipo = CAPITALISAR(NEW.rif_tipo);
IF NEW.rif_tipo = 'V' THEN
    SET NEW.rif_final = Null;
END IF;
END;$$


DELIMITER ;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
