#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import logging

from tkinter import ttk, messagebox, Tk, Toplevel

from scet.bd_xml import Tabla
from scet import libsa


__registro__ = logging.getLogger(__name__)
fila_defecto = 0


class Selector_Estandar(libsa.Ventana, libsa.Selector):
    nombre_objeto_lista = '__lista__'

    archivo_gui = None
    nombre_tabla = ''
    nombre_columna = 'nombre'

    def __init__(self, master, cnx, id=None):
        self.master = master

        self.__tabla__ = Tabla(self.nombre_tabla, cnx)

        libsa.Ventana.__init__(self, self.master, self.archivo_gui)
        libsa.Selector.__init__(self, tabla=self.__tabla__, id_extranjero=id)
        __registro__.debug(str(self.__tabla__))

        self.__lista__ = self.__gui__.get_object(self.nombre_objeto_lista)
        self.__lista__['values'] = [fila[self.nombre_columna] for fila in self.__tabla__]
        __registro__.debug(str([fila[self.nombre_columna] for fila in self.__tabla__]))

        self.__lista__.current(fila_defecto) if len(self.__lista__['values']) > 0 else None


class Empresas(Selector_Estandar):
    archivo_gui = 'S_Empresas'
    nombre_tabla = '_Empresas'
    nombre_columna = 'nombre'

    def __init__(self, master, cnx, id=None):
        Selector_Estandar.__init__(self, master, cnx, None)
